// This file was generated by Dashcode from Apple Computer, Inc.
// You may edit this file to customize your Dashboard widget.

function refreshVoteInfo()
{
   var xmlhttp = new XMLHttpRequest();
   var rawZipCode = widget.preferenceForKey(createInstancePreferenceKey("ZIP"));

   setVoteMessage(unescape('VoteWatch loading voting information%u2026'));
   if (rawZipCode)
   {
      var zipCode  = rawZipCode.replace(/[^0-9]/g, '');
      if (zipCode && zipCode.length == 5)
      {
         xmlhttp.open("GET", "http://capwiz.com/c-span/officials/congress/?lvl=C&only_votes=1&azip="+zipCode, true);
      }
      else if (zipCode && zipCode.length == 9)
      {
         var zipCodeA = zipCode.substring(0,5);
         var zipCodeB = zipCode.substring(5,9);
         xmlhttp.open("GET", "http://capwiz.com/c-span/officials/congress/?lvl=C&only_votes=1&azip="+zipCodeA+"&bzip="+zipCodeB, true);
      }
      else
      {
         xmlhttp.open("GET", "http://capwiz.com/c-span/issues/votes/", true);
      }
   }
   else
   {
      xmlhttp.open("GET", "http://capwiz.com/c-span/issues/votes/", true);
   }
   xmlhttp.onreadystatechange = function() { if (xmlhttp.readyState == 4) { setVoteInfo(xmlhttp.responseText); } }
   xmlhttp.send(null);
}

function setVoteInfo(rawText) {
   if (rawText == null)
   {
      return;
   }
   var pos = rawText.indexOf("MultiVoteScoreCard");
   var startText;
   if (pos > 0)
   {
      var tempText  = rawText.substring(pos);
      pos = tempText.indexOf("<tr align=");
      startText  = tempText.substring(pos);
      pos = startText.indexOf("<!-- Wend");
   }
   else
   {
      pos = rawText.indexOf("ClientKeyVotes");
      if (pos > 0)
      {
         var tempText  = rawText.substring(pos);
         pos = tempText.indexOf("<TR");
         startText  = tempText.substring(pos);
         pos = startText.indexOf("<!---Wend");
      }
   }
   if (pos > 0)
   {
      var shortText  = startText.substring(0, pos);
      var linkedText  = shortText.replace(/(class="cwsubnormal")><a href="\/([^"]*)"/g, '$1 onclick="widget.openURL(\'http://www.capwiz.com/$2\');"><a href="#"');
      var agreedText  = linkedText.replace(/Agreed To/g, '<img src="Images/yes.png" width="16" height="16">');
      var passedText  = agreedText.replace(/Passed/g, '<img src="Images/yes.png" width="16" height="16">');
      var failedText  = passedText.replace(/Failed/g, '<img src="Images/no.png" width="16" height="16">');
      var rejectedText  = failedText.replace(/Rejected/g, '<img src="Images/no.png" width="16" height="16">');
      var confirmedText  = rejectedText.replace(/Confirmed/g, '<img src="Images/yes.png" width="16" height="16">');
      var yesText  = confirmedText.replace(/>Y</g, '><img src="Images/yes.png" width="16" height="16"><');
      var noText  = yesText.replace(/>N</g, '><img src="Images/no.png" width="16" height="16"><');
      var imageText  = noText.replace(/width="50"/g, '');
      var dateText  = imageText.replace(/\/20[0-2][0-9]/g, '');
      var votedText  = dateText.replace(/<span[^>]*>voted<\/span>/g, '');
      var bgText  = votedText.replace(/bgcolor=\"[^"]*\"/g, '');
      var finalText  = bgText.replace(/width="385"/g, '');
      setVoteContent(finalText);
   }
   else
   {
      pos = rawText.indexOf("bzip");
      if (pos > 0)
      {
         setVoteMessage("The ZIP code splits legislative districts. Please provide the additional 4 digits of your complete 9-digit ZIP code.");
      }
      else
      {
         setVoteMessage("Problem loading voting information!");
      }
   }
}

function setScrollContent(ident, value) {
   var content = document.getElementById(ident).object.content;
	content.innerHTML = value;
	document.getElementById(ident).object.refresh();
}

function setVoteContent(value) {
   setScrollContent('voteInfo', '<table border=0 cellspacing=1 cellpadding=0> '+value+' </table>');
}

function setVoteMessage(value) {
   setScrollContent('voteInfo', '<img src="Images/yes.png"> '+value+' <img src="Images/no.png">');
}

function donate(event)
{
   widget.openURL('http://www.johnhaney.com/votewatch/donate/');
}


function load()
{
	setupParts();
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	widget.setPreferenceForKey(null, createInstancePreferenceKey("ZIP"));
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	refreshVoteInfo();
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";

   setScrollContent('backInfo', "VoteWatch shows key votes from the United States Congress.  Enter your ZIP code to see how your local senators and representatives voted on each item.<br><br>Go to <span onclick=\"widget.openURL('http://www.johnhaney.com/votewatch/');\"><a href=\"#\">www.johnhaney.com/votewatch</a></span> for more information.<br><br>Data is from cspan.org and all front links go to their site.<br><br>Visual design by Brendan Donohoe<br><br>Special thanks to my wife who encourages and inspires me:<br>Katie Haney");

   if(window.widget)
   {
      var zipCode = widget.preferenceForKey(createInstancePreferenceKey("ZIP"));
      var zipCodeObject = document.getElementById("zipcode");
      if (zipCode && zipCode.length > 0)
      {
         zipCodeObject.value = zipCode;
      }
      else
      {
         zipCodeObject.value = "";
      }
   }

	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front
   if(window.widget)
   {
      zipCode = document.getElementById("zipcode");
      widget.setPreferenceForKey(zipCode.value, createInstancePreferenceKey("ZIP"));
   }

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";

	refreshVoteInfo();

	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}
